# RISC 2008. Demo 1 - Basics
#
#
# This is a GAP demonstration file. 
# To run a demonstration enter the following:
# gap> ReadLib("demo.g");
# gap> Demonstration("filename.g");
# You may need the full path in the last command.
# Then press <Enter> to go to the next step or
# press <q> to terminate the demonstration.
#
# -------------------------------------------------
#
# You can use the GAP system as a calculator
#
;
# Integers and rationals
;
2*2;
( -4 + 130 ) * ( 5 + 6); 
# for a discussion of precedence in such expressions, see ?arith operators
;
(100+50)/25;
1235/67890;
Factorial(13);
Fibonacci(7);
;
# Large integers (the meaning of 'large' depends on the system)
;
2^200;
2^15000;
Length( String( last ) );
a := 2^20000;
a mod 1000; # note this new function
;
4 > 0;
1/2 < 2/4;
3 <= -17;
(245446687*a+166567) mod 11;
a := 2^32582657-1; # 44th Mersenne Prime (Sept 06)
time;
a mod 10^5;
;
# Comparisons
;
4 > 0;
1/2 < 2/4;
3 <= -17;
(1,2,3) <> (1,3,2)^(1,2);
;
# Booleans
;
not true;
true and false;
true or false;
IsBool(false);
IsBool(fail);
0 > -1 and (1,2) in AlternatingGroup(3);
;
# Permutations
;
(1,2,3)^(1,2);
17^(1,3,17,4,8);
(1,3,17,4,8)^-1;
LargestMovedPoint( last );
NrMovedPoints( last2 ); # and see ?permutations for many more
(1,3,17,4,8)=(3,17,4,8,1);
Elements( SymmetricGroup(4) );
;
# Finite field elements
;
Z(4)^2;
Z(4)^3 = Z(2);
Z(3)^2;
Field( last );
Elements( GF(8) );
m := Z(3)^0*[ [1,0], [1,1] ];
One( GF(3) );
Zero( GF(3) );
One( Integers );
Zero( Rationals );
;
# Variables
a := 7^2;
a - 1;
b := a;
a := a - 1;
a;
b;
NamesUserGVars();
100/3;
last; # last is special
3/100;
last;
last + 1;
last3;
;
