# RISC 2008. Demo 5 - Simple programs
#
#
# This is a GAP demonstration file. 
# To run a demonstration enter the following:
# gap> ReadLib("demo.g");
# gap> Demonstration("<demo-name>.g");
# You may need the full path in the last command.
# Then press <Enter> to go to the next step or
# press <q> to terminate demonstration.
#
# -------------------------------------------------
#
# Some elements of programming
;
# compute the number of partitions of a natural number n
;
nrparts:= function(n)
   local np;
   np:= function(n, m)
      local i, res;
      if n = 0 then
         return 1;
      fi;
      res:= 0;
      for i in [1..Minimum(n,m)] do
         res:= res + np(n-i, i);
      od;
      return res;
   end;
   return np(n,n);
end;
;
# note the use of local variables and the for loop
;
# this function is also an example of recursion
;
for i in [10..15] do Print( nrparts( i ), "\n" ); od;
;
# Changing the argument list in a for loop
;
l := [ 1, 2, 3, 4, 5, 6 ];
for i in l do
   Print( i, "\n" );
   if i mod 2 = 0 then Add( l, 3 * i/2  ); fi;
od;
;
# We can have a function with an arbitrary number of arguments
;
sum := function ( arg )
  local total, x;
  total := 0;
  for x in arg do
    total := total + x;                                           
  od;
  return total;
end;
;
# 'arg' is special
;
sum( 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 );
;
# break
;
g := Group((1,2,3,4,5),(1,2)(3,4)(5,6));
for x in g do
 if Order(x) = 3 then
  break;
 fi;
od;
;
x;
Order( x );
;
# Note that we could loop over the group - see ?iterators
;
# Similarly for continue
;
g := Group((1,2,3),(1,2));
for x in g do
  if Order(x) = 3 then
    continue;
  fi; 
Print(x,"\n");
od;
;
